summaryrefslogtreecommitdiffstats
path: root/tests/imfile-endregex-save-lf.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/imfile-endregex-save-lf.sh')
-rwxr-xr-xtests/imfile-endregex-save-lf.sh53
1 files changed, 53 insertions, 0 deletions
diff --git a/tests/imfile-endregex-save-lf.sh b/tests/imfile-endregex-save-lf.sh
new file mode 100755
index 0000000..32725f4
--- /dev/null
+++ b/tests/imfile-endregex-save-lf.sh
@@ -0,0 +1,53 @@
+#!/bin/bash
+# This is part of the rsyslog testbench, licensed under ASL 2.0
+# This test mimics the test imfile-readmode2.sh, but works via
+# endmsg.regex. It's kind of a base test for the regex functionality.
+echo ======================================================================
+echo [imfile-endregex-save-lf.sh]
+. ${srcdir:=.}/diag.sh init
+. $srcdir/diag.sh check-inotify
+mkdir "$RSYSLOG_DYNNAME.work"
+generate_conf
+add_conf '
+global(workDirectory="./'"$RSYSLOG_DYNNAME"'.work")
+module(load="../plugins/imfile/.libs/imfile")
+input(type="imfile"
+ File="./'$RSYSLOG_DYNNAME'.input"
+ Tag="file:"
+ startmsg.regex="^[^ ]")
+template(name="outfmt" type="list") {
+ constant(value="HEADER ")
+ property(name="msg" format="json")
+ constant(value="\n")
+}
+if $msg contains "msgnum:" then
+ action(
+ type="omfile"
+ file=`echo $RSYSLOG_OUT_LOG`
+ template="outfmt"
+ )
+'
+startup
+
+# write the beginning of the file
+echo 'msgnum:0
+ msgnum:1
+ msgnum:2' > $RSYSLOG_DYNNAME.input
+# the next line terminates our test. It is NOT written to the output file,
+# as imfile waits whether or not there is a follow-up line that it needs
+# to combine.
+echo 'END OF TEST' >> $RSYSLOG_DYNNAME.input
+# sleep a little to give rsyslog a chance to begin processing
+./msleep 500
+
+shutdown_when_empty # shut down rsyslogd when done processing messages
+wait_shutdown # we need to wait until rsyslogd is finished!
+
+printf 'HEADER msgnum:0\\\\n msgnum:1\\\\n msgnum:2\n' | cmp - $RSYSLOG_OUT_LOG
+if [ ! $? -eq 0 ]; then
+ echo "invalid multiline message generated, $RSYSLOG_OUT_LOG is:"
+ cat $RSYSLOG_OUT_LOG
+ exit 1
+fi;
+
+exit_test